'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _icons = require('@ant-design/icons');

require('@ant-design/compatible/assets/index.css');

var _zh_CN = require('antd/es/date-picker/locale/zh_CN');

var _zh_CN2 = _interopRequireDefault(_zh_CN);

var _antd = require('antd');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TimeRangePicker = _antd.TimePicker.RangePicker;

var FormItem = _antd.Form.Item;
var CheckboxGroup = _antd.Checkbox.Group;
var RadioGroup = _antd.Radio.Group;
var Option = _antd.Select.Option;
var MonthPicker = _antd.DatePicker.MonthPicker,
    RangePicker = _antd.DatePicker.RangePicker,
    WeekPicker = _antd.DatePicker.WeekPicker;


function C2FormItem(props) {

  var renderElement = function renderElement(item) {
    if (item.render) {
      return item.render();
    }
    switch (item.type) {
      case 'select':
        {
          var attribute = Object.assign({ style: { width: '100%' } }, item.attribute);
          return _react2.default.createElement(
            _antd.Select,
            attribute,
            item.options && item.options.map(function (o, i) {
              return _react2.default.createElement(
                Option,
                { key: i, value: o.value, disabled: !!o.disabled },
                o.label
              );
            })
          );
        }

      case 'number':
        {
          var _attribute = Object.assign({ style: { width: '100%' } }, item.attribute);
          return _react2.default.createElement(_antd.InputNumber, _attribute);
        }

      case 'textarea':
        return _react2.default.createElement(_antd.Input.TextArea, item.attribute);

      case 'checkbox':
        return _react2.default.createElement(_antd.Checkbox, item.attribute);

      case 'checkboxGroup':
        return _react2.default.createElement(CheckboxGroup, _extends({ options: item.options }, item.attribute));

      case 'radioGroup':
        return _react2.default.createElement(RadioGroup, _extends({ options: item.options }, item.attribute));

      case 'switch':
        return _react2.default.createElement(_antd.Switch, item.attribute);

      case 'hidden':
        return _react2.default.createElement(_antd.Input, { type: 'hidden' });

      case 'slider':
        return _react2.default.createElement(_antd.Slider, item.attribute);

      case 'rate':
        return _react2.default.createElement(_antd.Rate, item.attribute);

      case 'datePicker':
        {
          var _attribute2 = Object.assign({ style: { width: '100%' }, locale: _zh_CN2.default }, item.attribute);
          return _react2.default.createElement(_antd.DatePicker, _attribute2);
        }

      case 'monthPicker':
        {
          var _attribute3 = Object.assign({ style: { width: '100%' }, locale: _zh_CN2.default }, item.attribute);
          return _react2.default.createElement(MonthPicker, _attribute3);
        }

      case 'rangePicker':
        {
          var _attribute4 = Object.assign({ style: { width: '100%' }, locale: _zh_CN2.default }, item.attribute);
          return _react2.default.createElement(RangePicker, _attribute4);
        }

      case 'weekPicker':
        {
          var _attribute5 = Object.assign({ style: { width: '100%' }, locale: _zh_CN2.default }, item.attribute);
          return _react2.default.createElement(WeekPicker, _attribute5);
        }

      case 'timePicker':
        {
          var _attribute6 = Object.assign({ style: { width: '100%' }, locale: _zh_CN2.default }, item.attribute);
          return _react2.default.createElement(_antd.TimePicker, _attribute6);
        }

      case 'upload':
        return _react2.default.createElement(
          _antd.Upload,
          item.attribute,
          _react2.default.createElement(
            _antd.Button,
            null,
            _react2.default.createElement(_icons.UploadOutlined, null),
            ' ',
            item.uploadText ? item.uploadText : '选择文件'
          )
        );
      case "upload-img":
        return _react2.default.createElement(
          _antd.Upload,
          _extends({}, item.attribute, {
            listType: 'picture-card'
          }),
          _react2.default.createElement(_icons.PlusOutlined, null),
          _react2.default.createElement(
            'div',
            { className: 'ant-upload-text' },
            '\u4E0A\u4F20\u56FE\u7247'
          )
        );
      case 'autoComplete':
        return _react2.default.createElement(_antd.AutoComplete, item.attribute);

      case 'treeSelect':
        return _react2.default.createElement(_antd.TreeSelect, item.attribute);

      case 'password':
        return _react2.default.createElement(_antd.Input.Password, item.attribute);

      case 'inputGroup':
        return _react2.default.createElement(
          _antd.Input.Group,
          item.attribute,
          item.children
        );

      case 'timeRangePicker':
        {
          var _attribute7 = Object.assign({ style: { width: '100%' }, locale: _zh_CN2.default }, item.attribute);
          return _react2.default.createElement(TimeRangePicker, _attribute7);
        }
      default:
        return _react2.default.createElement(_antd.Input, item.attribute);

    }
  };
  //   const formItemLayout = props.alignType==='wrapper'?{
  //       labelCol: {
  //        // xs: { span: 24 },
  //         span: props.labelSpan ,
  //       },
  //       wrapperCol: {
  //        // xs: { span: 24 },
  //         span: props.wrapperSpan ,
  //       },
  //     }:props.alignType==='label'?null:{
  //       labelCol: {
  //        // xs: { span: 24 },
  //         span: 6 ,
  //       },
  //       wrapperCol: {
  //        // xs: { span: 24 },
  //         span: 18 ,
  //       },
  //     };

  var getFieldDecoratorOptions = function getFieldDecoratorOptions(item) {
    var rules = [];
    if (item.required) rules.push({ required: true, message: item.requiredMessage ? item.requiredMessage : '请填写' + item.label });
    if (item.regExp) rules.push({ pattern: item.regExp, message: item.regExpMessage ? item.regExpMessage : item.label + '格式错误' });
    var fieldDecoratorOptions = { rules: rules };
    if (item.fieldDecoratorOptions) fieldDecoratorOptions = item.fieldDecoratorOptions;
    if ("undefined" !== typeof item.initialValue) fieldDecoratorOptions.initialValue = item.initialValue;

    if (item.type === 'switch' || item.type === 'checkbox') {
      fieldDecoratorOptions.valuePropName = 'checked';
    }
    if (item.type === 'upload') {
      fieldDecoratorOptions.valuePropName = 'fileList';
    }

    return fieldDecoratorOptions;
  };

  var getRules = function getRules(item) {
    var rules = [];
    if (item.required) rules.push({ required: true, message: item.requiredMessage ? item.requiredMessage : '请填写' + item.label });
    if (item.regExp) rules.push({ pattern: item.regExp, message: item.regExpMessage ? item.regExpMessage : item.label + '格式错误' });
    if (item.fieldDecoratorOptions && item.fieldDecoratorOptions.rules) {
      rules = rules.concat(item.fieldDecoratorOptions.rules);
    }

    return rules;
  };

  return _react2.default.isValidElement(props.item) ? props.item : _react2.default.createElement(
    FormItem,
    _extends({ name: props.item.name }, props.item.formItemAttribute, { label: props.item.label, rules: getRules(props.item) }),
    renderElement(props.item)
  );
}

C2FormItem.propTypes = {
  item: _propTypes2.default.object,
  form: _propTypes2.default.object, //form
  labelSpan: _propTypes2.default.number,
  wrapperSpan: _propTypes2.default.number,
  alignType: _propTypes2.default.string,
  key: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string])
};

C2FormItem.defaultProps = {
  labelSpan: 8,
  wrapperSpan: 16
};

exports.default = C2FormItem;