"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = DataSelectModal;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _antd = require("antd");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function DataSelectModal(props) {
	var _useState = (0, _react.useState)([]),
	    _useState2 = _slicedToArray(_useState, 2),
	    selectDatas = _useState2[0],
	    setSelectDatas = _useState2[1];

	var _useState3 = (0, _react.useState)([]),
	    _useState4 = _slicedToArray(_useState3, 2),
	    disableDatas = _useState4[0],
	    setDisableDatas = _useState4[1];

	var _useState5 = (0, _react.useState)([]),
	    _useState6 = _slicedToArray(_useState5, 2),
	    selectedRowKeys = _useState6[0],
	    setSelectedRowKeys = _useState6[1];

	var _useState7 = (0, _react.useState)({ pageIndex: 1, pageSize: 10, total: 0 }),
	    _useState8 = _slicedToArray(_useState7, 2),
	    pagination = _useState8[0],
	    setPagination = _useState8[1];

	var _useState9 = (0, _react.useState)([]),
	    _useState10 = _slicedToArray(_useState9, 2),
	    dataSource = _useState10[0],
	    setDataSource = _useState10[1];

	var _useState11 = (0, _react.useState)('id'),
	    _useState12 = _slicedToArray(_useState11, 2),
	    id = _useState12[0],
	    setId = _useState12[1];

	var _useState13 = (0, _react.useState)('name'),
	    _useState14 = _slicedToArray(_useState13, 2),
	    name = _useState14[0],
	    setName = _useState14[1];

	var _useState15 = (0, _react.useState)(false),
	    _useState16 = _slicedToArray(_useState15, 2),
	    loading = _useState16[0],
	    setLoading = _useState16[1];

	(0, _react.useEffect)(function () {
		if (props.visible) {
			if (props.rowKey) setId(props.rowKey);
			if (props.name) setName(props.name);

			initData(props);
		}
	}, [props.visible]);

	(0, _react.useEffect)(function () {
		setLoading(props.loading);
	}, [props.loading]);

	(0, _react.useEffect)(function () {
		if (props.pagination) {
			setPagination(props.pagination);
		}
		setDataSource(props.dataSource);
	}, [props.dataSource, props.pagination]);

	(0, _react.useEffect)(function () {
		initData(props);
	}, [props.selectDatas]);

	var initData = function initData(props) {
		var selectDatasNew = props.selectDatas && [].concat(_toConsumableArray(props.selectDatas));
		var disableData = props.disableData || [];
		selectDatasNew.forEach(function (u) {
			var comUsers = disableData.filter(function (d) {
				return d[id] === u[id];
			});
			if (comUsers && comUsers.length > 0) {
				u.closable = false;
			} else {
				u.closable = true;
			}
		});
		disableData.forEach(function (u) {
			u.closable = false;
		});
		var selectedRowKeysNew = getSelectDataIds(selectDatasNew);
		setSelectDatas(selectDatasNew);
		setDisableDatas(disableData);
		setSelectedRowKeys(selectedRowKeysNew);
	};

	var getSelectDataIds = function getSelectDataIds(selectDatas) {
		var ids = [];
		selectDatas.forEach(function (v) {
			ids.push(v[props.rowKey]);
		});
		return ids;
	};

	//行选择
	var rowSelection = {
		selectedRowKeys: selectedRowKeys,
		onSelect: function onSelect(record, selected, selectedRows) {
			var selectedRowKeysNew = [].concat(_toConsumableArray(selectedRowKeys));
			var selectDatasNew = [].concat(_toConsumableArray(selectDatas));
			var closable = !disableDatas.map(function (u) {
				return u[id];
			}).includes(record[id]);
			record.closable = closable;
			if (selected) {
				selectDatasNew.push(record);
				selectedRowKeysNew.push(record[id]);
			} else {
				for (var i = 0; i < selectDatasNew.length; i++) {
					if (selectDatasNew[i][id] === record[id]) {
						selectDatasNew.splice(i, 1);
						break;
					}
				}
				selectedRowKeysNew = selectDatasNew.map(function (u) {
					return u[id];
				});
			}
			setSelectDatas(selectDatasNew);
			setSelectedRowKeys(selectedRowKeysNew);
		},
		onSelectAll: function onSelectAll(selected, selectedRows, changeRows) {
			var rowKeys = [],
			    datas = [];
			if (selected) {
				rowKeys = [].concat(_toConsumableArray(selectedRowKeys));
				datas = [].concat(_toConsumableArray(selectDatas));
				changeRows.forEach(function (element) {
					datas.push(element);
					rowKeys.push(element[id]);
				});
			} else {
				selectDatas.forEach(function (element) {
					var data = element;
					for (var n = 0; n < changeRows.length; n++) {
						if (data[id] === changeRows[n][id]) {
							data = null;
							break;
						}
					}
					if (data !== null) {
						rowKeys.push(data[id]);
						datas.push(data);
					}
				});
			}

			setSelectedRowKeys(rowKeys);
			setSelectDatas(datas);
		},
		getCheckboxProps: function getCheckboxProps(record) {
			var disabled = false;
			disableDatas.forEach(function (du) {
				if (du[id] === record[id]) {
					disabled = true;
				}
			});
			return { disabled: disabled };
		}

		//行点击
	};var onRow = function onRow(record) {
		return {
			onClick: function onClick(event) {
				var unselect = true;
				//禁用行忽略
				var disabledRow = false;
				disableDatas.forEach(function (du) {
					if (record[id] === du[id]) disabledRow = true;
				});
				if (disabledRow) {
					_antd.message.info('该记录不能进行操作。');
					return;
				}

				var closable = !disableDatas.map(function (u) {
					return u[id];
				}).includes(record[id]);
				record.closable = closable;

				var selectDatasNew = [].concat(_toConsumableArray(selectDatas));
				for (var i = 0; i < selectDatasNew.length; i++) {
					if (selectDatasNew[i][id] === record[id]) {
						unselect = false;
						selectDatasNew.splice(i, 1);
						break;
					}
				}
				if (unselect) {
					selectDatasNew.push(record);
				}

				setSelectDatas(selectDatasNew);
				setSelectedRowKeys(getSelectDataIds(selectDatasNew));
			}
		};
	};

	//拉取分页数据
	var tableOnChange = function tableOnChange(pagination) {
		if (props.tableOnChange) {
			props.tableOnChange(pagination);
		}
	};

	//删除已选记录
	var delUser = function delUser(userId) {
		var selectDatasNew = [].concat(_toConsumableArray(selectDatas));
		for (var i = 0; i < selectDatasNew.length; i++) {
			if (selectDatasNew[i][id] === userId) {
				selectDatasNew.splice(i, 1);
			}
		}
		setSelectDatas(selectDatasNew);
		setSelectedRowKeys(getSelectDataIds(selectDatasNew));
	};

	var columns = [{ title: "姓名", dataIndex: "name", key: "name", ellipsis: true }, { title: "手机号", dataIndex: "phone", key: "phone", ellipsis: true }, { title: "工号", key: "workno", dataIndex: "workno", ellipsis: true }];

	var onHandleOk = function onHandleOk() {
		if (props.onOk) {
			props.onOk(selectDatas);
		}
	};

	var handleCancle = function handleCancle() {
		if (props.onCancel) {
			setDataSource([]);
			setSelectDatas([]);
			setSelectedRowKeys([]);
			props.onCancel();
		}
	};

	return _react2.default.createElement(
		_antd.Modal,
		{ title: props.title,
			cancelText: "\u53D6\u6D88",
			okText: "\u786E\u5B9A",
			bodyStyle: _extends({ maxHeight: window.innerHeight - 250, overflowY: 'auto' }, props.bodyStyle),
			visible: props.visible, onOk: onHandleOk, onCancel: handleCancle, destroyOnClose: true, maskClosable: false,
			width: props.width ? props.width : 600 },
		props.description && _react2.default.createElement(_antd.Alert, { description: props.description, type: "info", style: { marginBottom: "10px" } }),
		props.noSelect ? _react2.default.createElement(_antd.Alert, { type: "info", description: "\u5DF2\u9009\u62E9\u3010" + selectDatas.length + "\u3011\u9879", size: "small", style: { marginBottom: 8, height: 40, paddingTop: 5 } }) : _react2.default.createElement(
			"div",
			{ className: "user-selected-tags", style: { minHeight: 32, marginBottom: 16 } },
			_react2.default.createElement(
				"strong",
				{ style: { marginRight: 8, marginTop: 15 } },
				props.mark ? props.mark : "已选数据",
				":"
			),
			selectDatas.length > 0 ? selectDatas.map(function (u) {
				return _react2.default.createElement(
					_antd.Tag,
					{ style: { marginTop: 5 }, key: id ? u[id] : u.id, closable: u.closable == null ? true : u.closable, onClose: function onClose(e) {
							delUser(id ? u[id] : u.id);
						} },
					name ? u[name] : u.name
				);
			}) : _react2.default.createElement(
				"div",
				{ style: { marginTop: 10 } },
				_react2.default.createElement(
					"a",
					{ disabled: "true" },
					"\u8FD8\u672A\u9009\u62E9\u6570\u636E"
				)
			)
		),
		_react2.default.isValidElement(props.searchView) ? props.searchView : '',
		_react2.default.createElement(_antd.Table, { rowKey: props.rowKey ? props.rowKey : 'id', size: "small", showSizeChanger: true, columns: props.columns ? props.columns : columns,
			dataSource: dataSource, pagination: pagination, loading: loading,
			rowSelection: rowSelection, onRow: onRow, onChange: tableOnChange })
	);
}