'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  .ant-legacy-form-item {\n    display: flex;\n  }\n  .ant-legacy-form-item-label {\n    flex: 1;\n  }\n'], ['\n  .ant-legacy-form-item {\n    display: flex;\n  }\n  .ant-legacy-form-item-label {\n    flex: 1;\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _compatible = require('@ant-design/compatible');

require('@ant-design/compatible/assets/index.css');

var _antd = require('antd');

var _DynamicFormItem = require('./DynamicFormItem');

var _DynamicFormItem2 = _interopRequireDefault(_DynamicFormItem);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var FlextForm = (0, _styledComponents2.default)(_compatible.Form)(_templateObject);

var FormItem = FlextForm.Item;

/**
 *动态表单编辑弹窗
 *
 * data属性：
 * label,name,attribute,required,requiredMessage,regExp,regExpMessage,fieldDecoratorOptions
 *
 */

var DynamicFormEditor = function (_PureComponent) {
    _inherits(DynamicFormEditor, _PureComponent);

    function DynamicFormEditor(props) {
        _classCallCheck(this, DynamicFormEditor);

        var _this = _possibleConstructorReturn(this, (DynamicFormEditor.__proto__ || Object.getPrototypeOf(DynamicFormEditor)).call(this, props));

        _this.state = {
            formItems: [],
            data: null
        };
        if (typeof props.getForm === 'function') props.getForm(props.form);

        _this.handleSubmit = _this.handleSubmit.bind(_this);
        return _this;
    }

    _createClass(DynamicFormEditor, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.props.data) {
                this.props.form.setFieldsValue(this.props.data);
            }
        }
    }, {
        key: 'handleSubmit',
        value: function handleSubmit() {
            var _this2 = this;

            this.props.form.validateFields(function (errors, values) {
                if (typeof _this2.props.onSubmit === 'function') _this2.props.onSubmit(errors, values);
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var formItems = this.state.formItems;

            var formLayout = {
                labelCol: { span: this.props.labelSpan },
                wrapperCol: { span: this.props.wrapperSpan }
            };
            var tailFormItemLayout = {
                wrapperCol: {
                    xs: {
                        span: 24,
                        offset: 0
                    },
                    sm: {
                        span: 16,
                        offset: 8
                    }
                }
            };

            var buttonItem = function buttonItem() {
                if (_this3.props.footer === null) return '';else if (_this3.props.footer === 'default') {
                    return _react2.default.createElement(
                        FormItem,
                        tailFormItemLayout,
                        _react2.default.createElement(
                            _antd.Button,
                            { type: 'primary', onClick: _this3.handleSubmit },
                            _this3.props.submitText
                        )
                    );
                } else if (_typeof(_this3.props.footer) === 'object') {
                    return _react2.default.createElement(
                        FormItem,
                        tailFormItemLayout,
                        _this3.props.footer
                    );
                }
            };
            return _react2.default.createElement(
                FlextForm,
                _extends({}, formLayout, this.props.formAttributes),
                _react2.default.createElement(
                    _antd.Row,
                    { gutter: this.props.gutter },
                    formItems.map(function (item, index) {
                        if (_this3.props.cols) {
                            var span = 24 / _this3.props.cols;
                            return _react2.default.isValidElement(item) ? item : _react2.default.createElement(
                                _antd.Col,
                                { span: item.span ? item.span : span },
                                _react2.default.createElement(_DynamicFormItem2.default, { alignType: _this3.props.alignType, item: item, key: index,
                                    labelSpan: item.labelSpan ? item.labelSpan : _this3.props.labelSpan, wrapperSpan: item.wrapperSpan ? item.wrapperSpan : _this3.props.wrapperSpan,
                                    dynamicform: _this3.props.form, data: _this3.props.data })
                            );
                        } else {
                            return _react2.default.isValidElement(item) ? item : _react2.default.createElement(
                                _antd.Col,
                                { span: item.span ? item.span : 24 },
                                _react2.default.createElement(_DynamicFormItem2.default, { alignType: _this3.props.alignType, item: item, key: index,
                                    labelSpan: item.labelSpan ? item.labelSpan : _this3.props.labelSpan, wrapperSpan: item.wrapperSpan ? item.wrapperSpan : _this3.props.wrapperSpan,
                                    dynamicform: _this3.props.form, data: _this3.props.data })
                            );
                        }
                    })
                ),
                buttonItem()
            );
        }
    }], [{
        key: 'getDerivedStateFromProps',
        value: function getDerivedStateFromProps(nextProps, prevState) {
            var formItems = [];
            var data = null;
            if (nextProps.items && nextProps.items instanceof Array) {
                formItems = [].concat(_toConsumableArray(nextProps.items));
            } else if (nextProps.items && nextProps.items instanceof Object) {
                formItems.push(nextProps.items);
            }
            if (nextProps.data && nextProps.data !== prevState.data) {
                data = nextProps.data;
                prevState.data = data;
                nextProps.form.setFieldsValue(nextProps.data);
            }
            if (formItems !== prevState.formItems) {
                prevState.formItems = formItems;
                return prevState;
            }
            return null;
        }
    }]);

    return DynamicFormEditor;
}(_react.PureComponent);

DynamicFormEditor.propTypes = {
    items: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object]), //表单元素定义
    data: _propTypes2.default.object, //数据
    formAttributes: _propTypes2.default.object,
    alignType: _propTypes2.default.string, //对齐方式
    getForm: _propTypes2.default.func, //antd form对象
    onChange: _propTypes2.default.func, //表单值改变事件
    onSubmit: _propTypes2.default.func, //默认的提交按钮事件
    submitText: _propTypes2.default.string, //提交按钮文本
    footer: _propTypes2.default.node, //自定义底部提交按钮
    labelSpan: _propTypes2.default.number,
    wrapperSpan: _propTypes2.default.number
};

DynamicFormEditor.defaultProps = {
    submitText: '提交',
    labelSpan: 8,
    wrapperSpan: 16,
    footer: 'default',
    formAttributes: {
        layout: 'horizontal'
    },
    alignType: 'wrapper'
};

exports.default = _compatible.Form.create({
    //表单值变化事件，回调到
    onValuesChange: function onValuesChange(props, changedValues, allValues) {
        if (typeof props.onChange === 'function') {
            if (props.data) {
                //暂只考虑编辑情况判断
                var changed = false;
                for (var key in changedValues) {
                    if (changedValues[key] !== props.data[key]) {
                        changed = true;
                        break;
                    }
                }
                props.onChange(props, changedValues, allValues, changed);
            } else {
                props.onChange(props, changedValues, allValues, true);
            }
        }
    }
})(DynamicFormEditor);