'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _templateObject = _taggedTemplateLiteral(['\n  .hover-editor .anticon-edit{\n  display: none;\n}\n\n.hover-editor:hover .anticon-edit {\n  display: inline;\n}\n'], ['\n  .hover-editor .anticon-edit{\n  display: none;\n}\n\n.hover-editor:hover .anticon-edit {\n  display: inline;\n}\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _icons = require('@ant-design/icons');

var _compatible = require('@ant-design/compatible');

require('@ant-design/compatible/assets/index.css');

var _antd = require('antd');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _C2Select = require('./C2Select');

var _C2Select2 = _interopRequireDefault(_C2Select);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var FormItem = _compatible.Form.Item;
var CheckboxGroup = _antd.Checkbox.Group;
var RadioGroup = _antd.Radio.Group;
var Option = _antd.Select.Option;
var MonthPicker = _antd.DatePicker.MonthPicker,
    RangePicker = _antd.DatePicker.RangePicker,
    WeekPicker = _antd.DatePicker.WeekPicker;

var EditorFormItem = (0, _styledComponents2.default)(FormItem)(_templateObject);

function DynamicFormEditorItem(props) {
  var _useState = (0, _react.useState)('read'),
      _useState2 = _slicedToArray(_useState, 2),
      mode = _useState2[0],
      updateMode = _useState2[1];

  (0, _react.useEffect)(function () {
    if (props.item.mode) {
      updateMode(props.item.mode);
    }
  });

  var getReadElement = function getReadElement(item) {
    if (item.render) {
      return item.render();
    }

    if (item.editType === 'tooltip') {
      return _react2.default.createElement(
        _antd.Tooltip,
        { placement: 'topLeft', title: item.tooltipTitle ? item.tooltipTitle : '点击编辑' },
        _react2.default.createElement(
          'span',
          { onClick: function onClick() {
              updateMode('write');
            }, style: { margin: 0, marginRight: 10 } },
          item.initialValue ? item.initialValue : item.nullValue
        )
      );
    } else if (item.editType === 'hover-pencil') {
      return _react2.default.createElement(
        'span',
        { className: 'hover-editor' },
        _react2.default.createElement(
          'span',
          { style: { margin: 0, marginRight: 10 } },
          item.initialValue ? item.initialValue : item.nullValue
        ),
        _react2.default.createElement(_icons.EditOutlined, { onClick: function onClick() {
            updateMode('write');
          } })
      );
    } else {
      //TODO:默认一直显示笔
      return _react2.default.createElement(
        'span',
        null,
        _react2.default.createElement(
          'span',
          { style: { margin: 10, marginRight: 10 } },
          item.initialValue ? item.initialValue : item.nullValue
        ),
        _react2.default.createElement(_icons.EditOutlined, { onClick: function onClick() {
            updateMode('write');
          } })
      );
    }
  };

  function onCancel() {
    props.dynamicform.resetFields();
    updateMode('read');
    if (typeof props.onCancel === 'function') props.onCancel();
  }

  function onSubmit() {
    props.dynamicform.validateFields(function (errors, values) {
      if (!errors) {
        updateMode('read');
        if (typeof props.onSubmit === 'function') {
          //将Moment类型value转化为字符串
          if (props.item.type === 'datePicker' || props.item.type === 'monthPicker' || props.item.type === 'weekPicker' || props.item.type === 'timePicker') {
            if (values[props.item.name]) {
              values[props.item.name] = values[props.item.name].format(props.item.attribute && props.item.attribute.format ? props.item.attribute.format : 'YYYY-MM-DD');
            }
          }
          if (props.item.type === 'rangePicker') {
            if (values[props.item.name]) {
              values[props.item.name] = [values[props.item.name][0].format(props.item.attribute && props.item.attribute.format ? props.item.attribute.format : 'YYYY-MM-DD'), values[props.item.name][1].format(props.item.attribute && props.item.attribute.format ? props.item.attribute.format : 'YYYY-MM-DD')];
            }
          }
          props.onSubmit(values);
        }
      }
    });
  }

  var renderButton = function renderButton(item) {
    if (_typeof(item.button) === 'object') {
      return item.button;
    }
    if (item.button === null) {
      return null;
    }
    if (item.button === 'button') {
      return [_react2.default.createElement(
        _antd.Button,
        { type: 'primary', style: { marginLeft: 5 }, size: 'small', onClick: function onClick() {
            return onSubmit();
          } },
        '\u786E\u5B9A'
      ), _react2.default.createElement(
        _antd.Button,
        { size: 'small', style: { marginLeft: 5 }, onClick: function onClick() {
            return onCancel();
          } },
        '\u53D6\u6D88'
      )];
    } else {
      return [_react2.default.createElement(_icons.CheckOutlined, {
        style: { fontSize: 16, marginLeft: 10, color: '#15469A', marginTop: 4 },
        onClick: onSubmit }), _react2.default.createElement(_icons.CloseOutlined, { style: { fontSize: 16, marginLeft: 10, marginTop: 4 }, onClick: onCancel })];
    }
  };

  var renderElement = function renderElement(item) {
    if (item.render) {
      return item.render();
    }
    switch (item.type) {
      case 'select':
        // return <Select {...item.attribute}>
        //         {item.options && item.options.map((o, i) =>
        //           <Option key={i} value={o.value} disabled={!!o.disabled}>{o.label}</Option>
        //         )}
        //       </Select>
        _react2.default.createElement(_C2Select2.default, { attribute: _extends({}, item.attribute), options: item.options, fetchUrl: item.fetchUrl });

      case 'number':
        var attribute = Object.assign({ style: { width: '100%' } }, item.attribute);
        return _react2.default.createElement(_antd.InputNumber, attribute);

      case 'textarea':
        return _react2.default.createElement(_antd.Input.TextArea, item.attribute);

      case 'checkbox':
        return _react2.default.createElement(_antd.Checkbox, item.attribute);

      case 'checkboxGroup':
        return _react2.default.createElement(CheckboxGroup, _extends({ options: item.options }, item.attribute));

      case 'radioGroup':
        return _react2.default.createElement(RadioGroup, _extends({ options: item.options }, item.attribute));

      case 'switch':
        return _react2.default.createElement(_antd.Switch, item.attribute);

      case 'hidden':
        return _react2.default.createElement(_antd.Input, { type: 'hidden' });

      case 'slider':
        return _react2.default.createElement(_antd.Slider, item.attribute);

      case 'rate':
        return _react2.default.createElement(_antd.Rate, item.attribute);

      case 'datePicker':
        {
          var _attribute = Object.assign({ style: { width: '100%' } }, item.attribute);
          return _react2.default.createElement(_antd.DatePicker, _attribute);
        }

      case 'monthPicker':
        {
          var _attribute2 = Object.assign({ style: { width: '100%' } }, item.attribute);
          return _react2.default.createElement(MonthPicker, _attribute2);
        }

      case 'rangePicker':
        {
          var _attribute3 = Object.assign({ style: { width: '100%' } }, item.attribute);
          return _react2.default.createElement(RangePicker, _attribute3);
        }

      case 'weekPicker':
        {
          var _attribute4 = Object.assign({ style: { width: '100%' } }, item.attribute);
          return _react2.default.createElement(WeekPicker, _attribute4);
        }

      case 'timePicker':
        {
          var _attribute5 = Object.assign({ style: { width: '100%' } }, item.attribute);
          return _react2.default.createElement(_antd.TimePicker, _attribute5);
        }

      case 'upload':
        return _react2.default.createElement(
          _antd.Upload,
          item.attribute,
          _react2.default.createElement(
            _antd.Button,
            null,
            _react2.default.createElement(_icons.UploadOutlined, null),
            ' ',
            item.uploadText ? item.uploadText : '选择文件'
          )
        );

      case 'autoComplete':
        return _react2.default.createElement(_antd.AutoComplete, item.attribute);

      case 'treeSelect':
        return _react2.default.createElement(_antd.TreeSelect, item.attribute);

      case 'inputGroup':
        return _react2.default.createElement(
          _antd.Input.Group,
          item.attribute,
          item.children
        );

      default:
        return _react2.default.createElement(_antd.Input, item.attribute);

    }
  };

  var fieldDecoratorOptions = function fieldDecoratorOptions(item) {
    var rules = [];
    if (item.required) rules.push({ required: true, message: item.requiredMessage ? item.requiredMessage : '请填写' + item.label });
    if (item.regExp) rules.push({ pattern: item.regExp, message: item.regExpMessage ? item.regExpMessage : item.label + '格式错误' });
    var fieldDecoratorOptions = { rules: rules };
    if (item.fieldDecoratorOptions) fieldDecoratorOptions = item.fieldDecoratorOptions;
    if ("undefined" !== typeof item.initialValue) fieldDecoratorOptions.initialValue = item.initialValue;
    if (item.type === 'switch' || item.type === 'checkbox') {
      fieldDecoratorOptions.valuePropName = 'checked';
    }
    if (item.type === 'datePicker' || item.type === 'monthPicker' || item.type === 'weekPicker' || item.type === 'timePicker') {
      if (fieldDecoratorOptions.initialValue && typeof fieldDecoratorOptions.initialValue === 'string') //initialValue为空时会默认当前时间
        fieldDecoratorOptions.initialValue = (0, _moment2.default)(fieldDecoratorOptions.initialValue);
    }
    if (item.type === 'rangePicker') {
      if (fieldDecoratorOptions.initialValue instanceof Array && typeof fieldDecoratorOptions.initialValue[0] === 'string' && typeof fieldDecoratorOptions.initialValue[1] === 'string') fieldDecoratorOptions.initialValue = [(0, _moment2.default)(fieldDecoratorOptions.initialValue[0]), (0, _moment2.default)(fieldDecoratorOptions.initialValue[1])];
    }
    if (item.type === 'upload') {
      fieldDecoratorOptions.valuePropName = 'fileList';
    }

    return fieldDecoratorOptions;
  };

  var getElement = function getElement(item) {
    if (item.type === 'textarea') {
      var left = item.attribute ? item.attribute.style ? item.attribute.style.width ? '-25px' : 0 : 0 : 0;
      return _react2.default.createElement(
        _antd.Col,
        null,
        _react2.default.createElement(
          _antd.Col,
          { span: 24 },
          props.dynamicform ? props.dynamicform.getFieldDecorator(item.name, fieldDecoratorOptions(item))(renderElement(item)) : renderElement(item)
        ),
        _react2.default.createElement(
          _antd.Col,
          { span: 24, style: { textAlign: 'right', marginLeft: left } },
          renderButton(item)
        )
      );
    } else {
      return _react2.default.createElement(
        _antd.Row,
        { style: { display: 'flex' } },
        _react2.default.createElement(
          _antd.Col,
          { style: { width: '100%' } },
          props.dynamicform ? props.dynamicform.getFieldDecorator(item.name, fieldDecoratorOptions(item))(renderElement(item)) : renderElement(item)
        ),
        _react2.default.createElement(
          _antd.Col,
          { style: { display: 'flex', marginTop: 8 } },
          renderButton(item)
        )
      );
    }
  };

  return _react2.default.isValidElement(props.item) ? props.item : _react2.default.createElement(
    EditorFormItem,
    _extends({ key: props.key }, props.item.formItemAttribute, {
      label: props.item.label, style: { display: props.item.display ? props.item.display : 'flex' } }),
    mode === 'write' ? getElement(props.item) : getReadElement(props.item)
  );
}

DynamicFormEditorItem.propTypes = {
  item: _propTypes2.default.object,
  dynamicform: _propTypes2.default.object, //form
  key: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  onSubmit: _propTypes2.default.func, //确定事件
  onCancel: _propTypes2.default.func //取消事件
};

exports.default = DynamicFormEditorItem;