'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _antd = require('antd');

var _DynamicFormEditor = require('./DynamicFormEditor');

var _DynamicFormEditor2 = _interopRequireDefault(_DynamicFormEditor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 *动态表单编辑弹窗
 *
 * @class DynamicFormEditorModal
 * @extends {Component}
 *
 * data属性：
 * label,name,value,attribute,required,requiredMessage,regExp,regExpMessage,fieldDecoratorOptions
 *
 * type: select,number,hidden,input(default)
 */
var DynamicFormEditorModal = function (_Component) {
    _inherits(DynamicFormEditorModal, _Component);

    function DynamicFormEditorModal(props) {
        _classCallCheck(this, DynamicFormEditorModal);

        var _this = _possibleConstructorReturn(this, (DynamicFormEditorModal.__proto__ || Object.getPrototypeOf(DynamicFormEditorModal)).call(this, props));

        _this.state = {
            form: null
        };

        _this.onOk = _this.onOk.bind(_this);
        _this.onCancel = _this.onCancel.bind(_this);
        return _this;
    }

    _createClass(DynamicFormEditorModal, [{
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            if (this.state.form && this.props.visible && typeof this.props.getForm === 'function') {
                this.props.getForm(this.state.form);
            }
        }
    }, {
        key: 'onOk',
        value: function onOk() {
            var _this2 = this;

            this.state.form.validateFields(function (errors, values) {
                if (!errors) {
                    if (typeof _this2.props.onOk === 'function') _this2.props.onOk(values);
                }
            });
        }
    }, {
        key: 'onCancel',
        value: function onCancel() {
            if (typeof this.props.onCancel === 'function') this.props.onCancel();
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            return _react2.default.createElement(
                _antd.Modal,
                {
                    title: this.props.title, maskClosable: false, width: this.props.width,
                    confirmLoading: this.props.confirmLoading,
                    visible: this.props.visible, style: this.props.style, destroyOnClose: true,
                    onOk: this.onOk, okText: this.props.okText, cancelText: this.props.cancelText,
                    onCancel: this.onCancel, footer: this.props.footer },
                _react2.default.createElement(_DynamicFormEditor2.default, { formAttributes: this.props.formAttributes, labelSpan: this.props.labelSpan,
                    wrapperSpan: this.props.wrapperSpan, onChange: this.props.onChange,
                    items: this.props.items, data: this.props.data,
                    cols: this.props.cols,
                    getForm: function getForm(form) {
                        return _this3.setState({ form: form });
                    }, footer: null })
            );
        }
    }]);

    return DynamicFormEditorModal;
}(_react.Component);

DynamicFormEditorModal.propTypes = {
    items: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object]),
    formAttributes: _propTypes2.default.object,
    data: _propTypes2.default.object,
    title: _propTypes2.default.string, //Modal框标题
    width: _propTypes2.default.number, //Modal宽度
    getForm: _propTypes2.default.func, //antd form对象
    visible: _propTypes2.default.bool, //显示
    footer: _propTypes2.default.object, //底部按钮
    okText: _propTypes2.default.string, //确认按钮文本
    cancelText: _propTypes2.default.string, //取消按钮文本
    onOk: _propTypes2.default.func, //确认按钮回调
    onCancle: _propTypes2.default.func //取消按钮回调
};

DynamicFormEditorModal.defaultProps = {
    title: '编辑',
    visible: false,
    confirmLoading: false,
    okText: '确定',
    cancelText: '取消'
};

exports.default = DynamicFormEditorModal;