'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n.ant-form-explain {\n  position: absolute;\n  font-size: 12px;\n  margin-top: -4px;\n}\n'], ['\n.ant-form-explain {\n  position: absolute;\n  font-size: 12px;\n  margin-top: -4px;\n}\n']);

exports.default = EditableCell;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _icons = require('@ant-design/icons');

var _compatible = require('@ant-design/compatible');

require('@ant-design/compatible/assets/index.css');

var _antd = require('antd');

var _EditableTableContext = require('./EditableTableContext');

var _EditableTableContext2 = _interopRequireDefault(_EditableTableContext);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _zh_CN = require('antd/es/date-picker/locale/zh_CN');

var _zh_CN2 = _interopRequireDefault(_zh_CN);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var FormItem = _compatible.Form.Item;
var CheckboxGroup = _antd.Checkbox.Group;
var RadioGroup = _antd.Radio.Group;
var Option = _antd.Select.Option;
var MonthPicker = _antd.DatePicker.MonthPicker,
    RangePicker = _antd.DatePicker.RangePicker,
    WeekPicker = _antd.DatePicker.WeekPicker;


var FormItemStyle = (0, _styledComponents2.default)(FormItem)(_templateObject);

function EditableCell(props) {
  var editing = props.editing,
      col = props.col,
      record = props.record,
      restProps = _objectWithoutProperties(props, ['editing', 'col', 'record']);

  var getInput = function getInput(col, record, form) {
    if (col.editRender && !record.mutilRender) {
      return col.editRender(record);
    } else if (record.mutilRender && col.editRender) {
      //指定什么时候使用自定义render，什么时候使用默认数据
      if (record[record.mutilRender]) {
        return col.editRender(record);
      } else {
        return getRender(col, record, form);
      }
    } else {
      return getRender(col, record, form);
    }
  };

  var getRender = function getRender(col, record, form) {
    switch (col.type) {
      case 'select':
        return _react2.default.createElement(
          _antd.Select,
          col.attribute,
          col.options && col.options.map(function (o, i) {
            return _react2.default.createElement(
              Option,
              { key: i, value: o.value, disabled: !!o.disabled },
              o.label
            );
          })
        );

      case 'number':
        var attribute = Object.assign({ style: { width: '100%' } }, col.attribute);
        return _react2.default.createElement(_antd.InputNumber, attribute);

      case 'textarea':
        return _react2.default.createElement(_antd.Input.TextArea, col.attribute);

      case 'checkbox':
        return _react2.default.createElement(_antd.Checkbox, col.attribute);

      case 'checkboxGroup':
        return _react2.default.createElement(CheckboxGroup, _extends({ options: col.options }, col.attribute));

      case 'radioGroup':
        return _react2.default.createElement(RadioGroup, _extends({ options: col.options }, col.attribute));

      case 'switch':
        return _react2.default.createElement(_antd.Switch, col.attribute);

      case 'hidden':
        return _react2.default.createElement(_antd.Input, { type: 'hidden' });

      case 'slider':
        return _react2.default.createElement(_antd.Slider, col.attribute);

      case 'rate':
        return _react2.default.createElement(_antd.Rate, col.attribute);

      case 'datePicker':
        {
          var attr = Object.assign({ style: { width: '100%' }, locale: _zh_CN2.default }, col.attribute);
          console.log(attr);
          // return <DatePicker picker='date'/>
          return _react2.default.createElement(_antd.DatePicker, attr);
        }

      case 'monthPicker':
        {
          var _attr = Object.assign({ style: { width: '100%' }, locale: _zh_CN2.default }, col.attribute);
          return _react2.default.createElement(MonthPicker, _attr);
        }

      case 'rangePicker':
        {
          var _attr2 = Object.assign({ style: { width: '100%' }, locale: _zh_CN2.default }, col.attribute);
          return _react2.default.createElement(RangePicker, _attr2);
        }

      case 'weekPicker':
        {
          var _attr3 = Object.assign({ style: { width: '100%' }, locale: _zh_CN2.default }, col.attribute);
          return _react2.default.createElement(WeekPicker, _attr3);
        }

      case 'timePicker':
        {
          var _attr4 = Object.assign({ style: { width: '100%' }, locale: _zh_CN2.default }, col.attribute);
          return _react2.default.createElement(_antd.TimePicker, _attr4);
        }

      case 'upload':
        return _react2.default.createElement(
          _antd.Upload,
          col.attribute,
          _react2.default.createElement(
            _antd.Button,
            null,
            _react2.default.createElement(_icons.UploadOutlined, null),
            ' ',
            col.uploadText ? col.uploadText : '选择文件'
          )
        );

      case 'autoComplete':
        return _react2.default.createElement(_antd.AutoComplete, col.attribute);

      case 'treeSelect':
        return _react2.default.createElement(_antd.TreeSelect, col.attribute);

      case 'inputGroup':
        return _react2.default.createElement(
          _antd.Input.Group,
          col.attribute,
          col.children
        );

      default:
        return _react2.default.createElement(_antd.Input, col.attribute);

    }
  };

  var getFieldDecoratorOptions = function getFieldDecoratorOptions(item, record) {
    var rules = [];
    if (item.required) rules.push({ required: true, message: item.requiredMessage ? item.requiredMessage : '请填写' + item.title });
    if (item.regExp) rules.push({ pattern: item.regExp, message: item.regExpMessage ? item.regExpMessage : item.title + '格式错误' });
    var fieldDecoratorOptions = { rules: rules };
    if (item.fieldDecoratorOptions) fieldDecoratorOptions = item.fieldDecoratorOptions;
    if ("undefined" !== typeof item.initialValue && !record[item.dataIndex]) {
      fieldDecoratorOptions.initialValue = item.initialValue;
    } else {
      fieldDecoratorOptions.initialValue = record[item.dataIndex];
    }

    if (item.type === 'switch' || item.type === 'checkbox') {
      fieldDecoratorOptions.valuePropName = 'checked';
    }
    if (item.type === 'upload') {
      fieldDecoratorOptions.valuePropName = 'fileList';
    }

    return fieldDecoratorOptions;
  };

  return _react2.default.createElement(
    _EditableTableContext2.default.Consumer,
    null,
    function (form) {
      var getFieldDecorator = form.getFieldDecorator;
      //let {editing,col,record,index} = props;

      if (editing) {
        if (col.type === "checkboxGroup") {
          if (!Array.isArray(record[col.dataIndex])) {
            record[col.dataIndex] = [record[col.dataIndex]];
          }
        }
      }
      return _react2.default.createElement(
        'td',
        restProps,
        editing ? _react2.default.createElement(
          FormItemStyle,
          {
            style: { margin: 0 } },
          getFieldDecorator(col.dataIndex, getFieldDecoratorOptions(col, record))(getInput(col, record, form))
        ) : restProps.children
      );
    }
  );
}