'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _compatible = require('@ant-design/compatible');

var _antd = require('antd');

var _EditableRow = require('./EditableRow');

var _EditableRow2 = _interopRequireDefault(_EditableRow);

var _EditableCell = require('./EditableCell');

var _EditableCell2 = _interopRequireDefault(_EditableCell);

var _EditableTableContext = require('./EditableTableContext');

var _EditableTableContext2 = _interopRequireDefault(_EditableTableContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EditableTable = function (_Component) {
	_inherits(EditableTable, _Component);

	function EditableTable(props) {
		var _this2 = this;

		_classCallCheck(this, EditableTable);

		var _this = _possibleConstructorReturn(this, (EditableTable.__proto__ || Object.getPrototypeOf(EditableTable)).call(this, props));

		_this.initColumns = function () {
			var editCol = true;
			if (_this.props.tableAttribute && _this.props.tableAttribute.editCol === false) {
				editCol = false;
			}
			if (_this.props.editing && editCol) {
				var row = {
					title: '操作',
					dataIndex: 'actions',
					width: 120,
					render: function render(text, record) {
						var editable = _this.isEditing(record);
						return _react2.default.createElement(
							'div',
							null,
							editable ? _react2.default.createElement(
								'span',
								null,
								_react2.default.createElement(
									_EditableTableContext2.default.Consumer,
									null,
									function (form) {
										return _react2.default.createElement(
											'a',
											{ onClick: function onClick() {
													return _this.saveRecord(form, record);
												} },
											'\u4FDD\u5B58'
										);
									}
								),
								_react2.default.createElement(_antd.Divider, { type: 'vertical' }),
								_react2.default.createElement(
									'a',
									{ onClick: function onClick() {
											return _this.cancel(record);
										} },
									'\u53D6\u6D88'
								)
							) : _this.props.optCol ? _this.props.optCol : _react2.default.createElement(
								'span',
								null,
								_react2.default.createElement(
									'a',
									{ disabled: _this.props.editdisabledKey ? record[_this.props.editdisabledKey] : false, onClick: function onClick() {
											return _this.edit(record);
										} },
									record.editTxt ? record.editTxt : _this.props.editTxt ? _this.props.editTxt : '编辑'
								),
								_react2.default.createElement(_antd.Divider, { type: 'vertical' }),
								_react2.default.createElement(
									_antd.Popconfirm,
									{
										title: '\u786E\u8BA4\u5220\u9664?',
										okText: '\u786E\u5B9A',
										cancelText: '\u53D6\u6D88',
										onConfirm: function onConfirm() {
											return _this.TemplateDeleteRow(record);
										}
									},
									_react2.default.createElement(
										'a',
										{ disabled: _this.props.deletedisabledKey ? record[_this.props.deletedisabledKey] : false },
										record.deleteTxt ? record.deleteTxt : _this.props.deleteTxt ? _this.props.deleteTxt : '删除'
									)
								)
							)
						);
					}
				};
				var columns = [].concat(_toConsumableArray(_this.props.columns));
				columns.push(row);
				// this.props.columns.push(row);
				_this.setState({ columns: columns });
			} else {
				_this.setState({ columns: _this.props.columns });
			}
		};

		_this.addTemplateRow = function (e) {
			var _newData;

			var newId = Math.random();
			var newData = (_newData = {}, _defineProperty(_newData, _this.state.rowKey, newId), _defineProperty(_newData, 'newRow', true), _newData);
			var data = [].concat(_toConsumableArray(_this.state.data));
			data.push(newData);
			_this.setState({ editingKey: newId, data: data, disabled: true });
		};

		_this.isEditing = function (record) {
			return record[_this.state.rowKey] === _this.state.editingKey;
		};

		_this.edit = function () {
			var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(record) {
				return regeneratorRuntime.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								if (!_this.props.onEdit) {
									_context.next = 3;
									break;
								}

								_context.next = 3;
								return _this.props.onEdit(record);

							case 3:
								_this.setState({ editingKey: record[_this.state.rowKey], disabled: true });

							case 4:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, _this2);
			}));

			return function (_x) {
				return _ref.apply(this, arguments);
			};
		}();

		_this.cancel = function () {
			var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(record) {
				var data;
				return regeneratorRuntime.wrap(function _callee2$(_context2) {
					while (1) {
						switch (_context2.prev = _context2.next) {
							case 0:
								if (!record.newRow) {
									_context2.next = 6;
									break;
								}

								data = [].concat(_toConsumableArray(_this.state.data));

								data.pop();
								_this.setState({ data: data, editingKey: '', disabled: false });
								_context2.next = 10;
								break;

							case 6:
								if (!_this.props.onCancel) {
									_context2.next = 9;
									break;
								}

								_context2.next = 9;
								return _this.props.onCancel(record);

							case 9:
								// let data = [...this.state.data];
								_this.setState({ editingKey: '', disabled: false });

							case 10:
							case 'end':
								return _context2.stop();
						}
					}
				}, _callee2, _this2);
			}));

			return function (_x2) {
				return _ref2.apply(this, arguments);
			};
		}();

		_this.TemplateDeleteRow = function () {
			var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(record) {
				var data;
				return regeneratorRuntime.wrap(function _callee3$(_context3) {
					while (1) {
						switch (_context3.prev = _context3.next) {
							case 0:
								if (!(typeof _this.props.onEditColOptions === 'function')) {
									_context3.next = 3;
									break;
								}

								_context3.next = 3;
								return _this.props.onEditColOptions('delete', record);

							case 3:
								data = _this.state.data.filter(function (d) {
									return d[_this.state.rowKey] !== record[_this.state.rowKey];
								});

								_this.setState({ data: data });

							case 5:
							case 'end':
								return _context3.stop();
						}
					}
				}, _callee3, _this2);
			}));

			return function (_x3) {
				return _ref3.apply(this, arguments);
			};
		}();

		_this.saveRecord = function (form, record) {
			form.validateFields(function () {
				var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(error, row) {
					var obj;
					return regeneratorRuntime.wrap(function _callee4$(_context4) {
						while (1) {
							switch (_context4.prev = _context4.next) {
								case 0:
									if (!error) {
										_context4.next = 2;
										break;
									}

									return _context4.abrupt('return');

								case 2:
									obj = Object.assign(record, row);

									if (!(typeof _this.props.onEditColOptions === 'function')) {
										_context4.next = 6;
										break;
									}

									_context4.next = 6;
									return _this.props.onEditColOptions('save', obj);

								case 6:
									_this.setState({ editingKey: "", disabled: false });

								case 7:
								case 'end':
									return _context4.stop();
							}
						}
					}, _callee4, _this2);
				}));

				return function (_x4, _x5) {
					return _ref4.apply(this, arguments);
				};
			}());
		};

		_this.renderAddButton = function () {
			if (_this.props.addButtonAttribute === null) return;
			if (_this.props.addButtonAttribute.render) {
				return _this.props.addButtonAttribute.render();
			}
			return _react2.default.createElement(
				_antd.Button,
				{ type: _this.state.buttonType, icon: _react2.default.createElement(_compatible.Icon, { type: _this.state.buttonIcon }), disabled: _this.state.disabled, style: { width: '100%', margin: '12px 0 24px' }, onClick: _this.addTemplateRow },
				_this.state.buttonText
			);
		};

		_this.state = {
			columns: [],
			data: [],
			editingKey: '',
			rowKey: 'key',
			buttonText: '新增',
			position: 'bottom',
			buttonType: 'dashed',
			buttonIcon: 'plus',
			disabled: false
		};
		return _this;
	}

	_createClass(EditableTable, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.setState({ data: this.props.data });
			if (this.props.tableAttribute) {
				if (this.props.tableAttribute.rowKey) this.setState({ rowKey: this.props.tableAttribute.rowKey });
			}
			if (this.props.addButtonAttribute) {
				if (this.props.addButtonAttribute.buttonIcon) this.setState({ buttonIcon: this.props.addButtonAttribute.buttonIcon });
				if (this.props.addButtonAttribute.buttonType) this.setState({ buttonType: this.props.addButtonAttribute.buttonType });
				if (this.props.addButtonAttribute.buttonText) this.setState({ buttonText: this.props.addButtonAttribute.buttonText });
				if (this.props.addButtonAttribute.position) this.setState({ position: this.props.addButtonAttribute.position });
			}
			this.initColumns();
		}
	}, {
		key: 'componentDidUpdate',
		value: function componentDidUpdate(props) {
			if (props.data !== this.props.data) {
				this.setState({ data: this.props.data, editingKey: '', disabled: false });
			}
			if (props.columns !== this.props.columns) {
				this.initColumns();
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			var components = {
				body: {
					row: _EditableRow2.default,
					cell: _EditableCell2.default
				}
			};

			var columns = this.state.columns.map(function (col) {
				if (!col.editable) {
					return col;
				}
				return _extends({}, col, {
					onCell: function onCell(record) {
						console.log({
							record: record,
							col: col,
							editing: _this3.isEditing(record)
						});
						return {
							record: record,
							col: col,
							editing: _this3.isEditing(record)
						};
					}
				});
			});

			return _react2.default.createElement(
				_react.Fragment,
				null,
				this.state.position === 'top' && this.props.editing ? this.renderAddButton() : '',
				_react2.default.createElement(_antd.Table, _extends({
					components: components,
					dataSource: this.state.data,
					columns: columns
				}, this.props.tableAttribute)),
				this.state.position === 'bottom' && this.props.editing ? this.renderAddButton() : ''
			);
		}
	}]);

	return EditableTable;
}(_react.Component);

EditableTable.propTypes = {
	columns: _propTypes2.default.array, //表格列配置
	data: _propTypes2.default.array,
	editing: _propTypes2.default.bool, //编辑状态
	tableAttribute: _propTypes2.default.object, //表格属性配置
	addButtonAttribute: _propTypes2.default.object, //新增按钮属性配置
	onEditColOptions: _propTypes2.default.func //操作列保存方法,有两个参数（type,record）
};

EditableTable.defaultProps = {
	editing: true,
	addButtonAttribute: { buttonIcon: 'plus', buttonText: '新增', buttonType: 'dashed' },
	tableAttribute: { editCol: true, rowKey: 'key' }
};

exports.default = EditableTable;