'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = TagManager;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _compatible = require('@ant-design/compatible');

var _antd = require('antd');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function TagManager(props) {
    var _useState = (0, _react.useState)({}),
        _useState2 = _slicedToArray(_useState, 2),
        selectedTags = _useState2[0],
        setSelectTags = _useState2[1];

    var _useState3 = (0, _react.useState)({}),
        _useState4 = _slicedToArray(_useState3, 2),
        allTags = _useState4[0],
        setAllTags = _useState4[1];

    var _useState5 = (0, _react.useState)(),
        _useState6 = _slicedToArray(_useState5, 2),
        item = _useState6[0],
        setItem = _useState6[1]; //选中的条目


    var _useState7 = (0, _react.useState)(),
        _useState8 = _slicedToArray(_useState7, 2),
        searchTxt = _useState8[0],
        setSearchTxt = _useState8[1]; //输入的搜索字段


    var _useState9 = (0, _react.useState)(),
        _useState10 = _slicedToArray(_useState9, 2),
        value = _useState10[0],
        setValue = _useState10[1];

    var _useState11 = (0, _react.useState)(),
        _useState12 = _slicedToArray(_useState11, 2),
        focus = _useState12[0],
        setFocus = _useState12[1];

    (0, _react.useEffect)(function () {
        setValue(undefined);
        setSearchTxt(undefined);
        if (props.selectedTags && props.allTags) {
            var tags = {};
            props.allTags.forEach(function (element) {
                tags[element.id] = element;
            });
            setAllTags(tags);

            var stags = {};
            props.selectedTags.forEach(function (ele) {
                stags[ele.id] = ele.name;
            });
            setSelectTags(stags);
        }
    }, [props]);

    //改变标签可见的回调函数
    var onVisibleChange = function onVisibleChange(visible) {
        props.onVisibleChange && props.onVisibleChange(visible);
    };

    var onSearch = function onSearch(value) {
        if (focus) setSearchTxt(value);
    };

    //匹配已存在标签/创建新标签，并绑定标签
    var onTagsManagerCommit = function onTagsManagerCommit() {
        //无有效选中或输入过滤
        if (!item && !searchTxt) {
            props.onVisibleChange && props.onVisibleChange(false);
        } else {
            if (searchTxt != null) {
                var result = [];
                var resultCorrect = true;
                props.selectedTags.forEach(function (i) {
                    if (i.name === searchTxt) resultCorrect = false;
                });
                for (var key in allTags) {
                    if (allTags[key].name === searchTxt && resultCorrect) {
                        result.push(allTags[key]);
                    }
                }
                //绑定输入框中匹配的已存在标签
                if (result.length > 0) {
                    props.onChange && props.onChange({ event: 'add', value: result[0] });
                } else {
                    //创建绑定标签
                    if (resultCorrect) props.onChange && props.onChange({ event: 'create', value: { name: searchTxt } });
                }
            } else {
                props.onChange && props.onChange({ event: 'add', value: item });
            }
            setItem(undefined);
            setSearchTxt(undefined);
            props.onVisibleChange && props.onVisibleChange(false);
        }
    };

    //移除标签逻辑
    var removeTag = function removeTag(tag) {
        props.onChange && props.onChange({ event: 'remove', value: tag });
    };

    var renderTagsAddContainer = _react2.default.createElement(
        _antd.Row,
        { type: 'flex' },
        _react2.default.createElement(
            _antd.Col,
            null,
            _react2.default.createElement(
                _antd.Select,
                {
                    showSearch: true,
                    style: { width: 200 },
                    placeholder: '\u8F93\u5165\u65B0\u6807\u7B7E',
                    optionFilterProp: 'children',
                    value: value,
                    onMouseLeave: function onMouseLeave() {
                        return setFocus(false);
                    },
                    onMouseEnter: function onMouseEnter() {
                        return setFocus(true);
                    },
                    onSearch: onSearch,
                    onSelect: function onSelect(value) {
                        setValue(value);setItem(allTags[value]);
                    },
                    filterOption: function filterOption(input, option) {
                        return option.props.children.toLowerCase().indexOf(input.toLowerCase()) >= 0;
                    } },
                props.allTags && props.allTags.length > 0 ? props.allTags.map(function (element) {
                    return _react2.default.createElement(
                        _antd.Select.Option,
                        { key: element.id, disabled: !!selectedTags[element.id], value: element.id },
                        element.name
                    );
                }) : ''
            )
        ),
        _react2.default.createElement(
            _antd.Col,
            null,
            _react2.default.createElement(_antd.Button, { style: { marginLeft: 10 }, icon: _react2.default.createElement(_compatible.Icon, { type: 'check' }), onClick: onTagsManagerCommit }),
            _react2.default.createElement(_antd.Button, { style: { marginLeft: 10 }, icon: _react2.default.createElement(_compatible.Icon, { type: 'close' }), onClick: function onClick() {
                    props.onVisibleChange && props.onVisibleChange(false);
                } })
        )
    );

    return _react2.default.createElement(
        'span',
        { style: _extends({ justifyContent: 'center', lineHeight: '22px' }, props.style) },
        props.selectedTags && props.selectedTags.length > 0 ? props.selectedTags.map(function (element) {
            return _react2.default.createElement(
                _antd.Tag,
                { key: element.id, style: { marginRight: 10 }, closable: true, onClose: function onClose() {
                        removeTag(element);
                    } },
                element.name
            );
        }) : '',
        _react2.default.createElement(
            _antd.Popover,
            { visible: props.visible, trigger: 'click', onVisibleChange: onVisibleChange, content: renderTagsAddContainer, title: props.title },
            _react2.default.createElement(_antd.Button, { shape: props.shape, type: props.type, icon: _react2.default.createElement(_compatible.Icon, { type: props.icon }), size: props.size })
        )
    );
}

TagManager.propTypes = {
    selectedTags: _propTypes2.default.array,
    allTags: _propTypes2.default.array,
    visible: _propTypes2.default.bool,
    type: _propTypes2.default.string,
    icon: _propTypes2.default.string,
    shape: _propTypes2.default.string,
    size: _propTypes2.default.string,
    title: _propTypes2.default.string,
    style: _propTypes2.default.object,
    onVisibleChange: _propTypes2.default.func,
    onChange: _propTypes2.default.func
};

TagManager.defaultProps = {
    type: 'dashed',
    icon: 'plus',
    size: 'small',
    title: '添加标签'
};